#ifndef OM_SINGLE_VIRTUAL_INHERITANCE_H_
#define OM_SINGLE_VIRTUAL_INHERITANCE_H_

// ̳ģʽ£̳
// û¶virtual ʱĲ :
// ͵ַ -> ߵַ
// vbptr,Ԫ, Ԫ.
// ,λһڴ洢β,ҪһнܷĶ
// Ȼûvirtual,ҲҪһvbptr



#include "om-port.h"
//////////////////////////////////////////////////////////////////////////
// Եһ̳ϵµڴ沼(̳)
namespace om_ns_svi {

 class CParent {
 public:
  CParent ():iparent_ (10) {}
  int iparent_;
 };

 class CChild_a : virtual public CParent {
 public:
  CChild_a():ichild_(100) {}
  int ichild_;
 };

 class CChild_b : virtual public CParent {
 public:
  CChild_b():ichild_(100) {}
  virtual void f(){ cout<<"CChild_b::f()"<<endl;}
  int ichild_;
 };

 class CParent_vf {
 public:
  CParent_vf ():iparent_ (10) {}
  virtual void f() { cout << "CParent_vf::f()" << endl;}
  virtual void g() { cout << "CParent_vf::g()" << endl;}
  int iparent_;
 };

 class CChild_c : virtual public CParent_vf {
 public:
  CChild_c():ichild_(100) {}
  virtual void f(){ cout << "CChild_c::f()" << endl;}
  virtual void h(){ cout << "CChild_c::h()" << endl;}
  int ichild_;
 };


 inline void TestSingleVirtualInheritance() {
#pragma warning(push)
#pragma warning(disable:4312 4311)

  int i = 0;
  Ptr_Void_Fun pFun = NULL;
  int** pVTable = NULL;
  cout << "                        Test Single Virtual Inheritance                     "<<endl;
  cout << "***************************************************************************" <<endl;
  cout << endl << "--------------- Test CChild_a" << endl;
  CChild_a cda;
  pVTable = (int**)&cda;
  cout << "size: " << sizeof(cda) << endl; // 麯һָ
  cout << (int*)&pVTable[0] << "\t" << "[0] CChild_a::vbptr" << endl;
  cout << "\t\t\t" << "[0] CChild_a::vbptr for CChild_a  (" << &pVTable[0][0] << ")  = " <<pVTable[0][0]<< endl;
  cout << "\t\t\t" << "[1] CChild_a::vbptr for CParent   (" << &pVTable[0][1] << ")  = " <<pVTable[0][1]<< endl;

  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_a.ichild_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CParent.iparent_ = " << (int)pVTable[2] << endl;

  cout << endl << "--------------- Test CChild_b" << endl;
  CChild_b cdb;
  pVTable = (int**)&cdb;
  cout << "size: " << sizeof(cdb) << endl;
  // GCC£µһڲһ
  cout << (int*)&pVTable[0] << "\t" << "[0] CChild_b::vfptr->" << endl;
#if defined(OM_COMPILER_MSVC_)
  for (i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
#else
  for (i = 0; (Ptr_Void_Fun)pVTable[0][i+1] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
  cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;;
#endif

#if defined(OM_COMPILER_MSVC_)
  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_b::vbptr" << endl;
  cout << "\t\t\t" << "[0] CChild_b::vbptr for CChild_b  (" << &pVTable[1][0] << ")  = " <<pVTable[1][0]<< endl;
  cout << "\t\t\t" << "[1] CChild_b::vbptr for CParent (" << &pVTable[1][1] << ")  = " <<pVTable[1][1]<< endl;

  cout << (int*)&pVTable[2] << "\t" << "[2] CChild_b.ichild_ = " << (int)pVTable[2] << endl;
  cout << (int*)&pVTable[3] << "\t" << "[3] CParent.iparent_ = " << (int)pVTable[3] << endl;
#else
  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_b.ichild_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CParent.iparent_ = " << (int)pVTable[2] << endl;
#endif

   cout << endl << "--------------- Test CParent_vf" << endl;
   CParent_vf cpvf;
   pVTable = (int**)&cpvf;
   cout << "size: " << sizeof(cpvf) << endl;
   cout << (int*)&pVTable[0] << "\t" <<"[0] CParent::_vptr->" << endl;

#if defined(OM_COMPILER_MSVC_)
   for (i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
    pFun = (Ptr_Void_Fun)pVTable[0][i];
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
    pFun();
   }
#else
  for (i = 0; (Ptr_Void_Fun)pVTable[0][i+1] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }
  cout << "\t\t\t["<<i<<"] " << "\t" << &pVTable[0][i] << "\t" <<(int)pVTable[0][i] << endl;;
#endif

   cout << (int*)&pVTable[1] << "\t" << "[1] CParent.iparent_ = " << (int)pVTable[1] << endl;

  cout << endl << "--------------- Test CChild_c" << endl;
  CChild_c cdc;
  pVTable = (int**)&cdc;
  cout << "size: " << sizeof(cdc) << endl; // 麯һָ
  cout << (int*)&pVTable[0] << "\t" << "[0] CChild_c::vfptr" << endl;

  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun();
  }



#if defined(OM_COMPILER_MSVC_)
  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_c::vbptr" << endl;
  cout << "\t\t\t" << "[0] CChild_c::vbptr for CChild_b    (" << &pVTable[1][0] << ")  = " <<pVTable[1][0]<< endl;
  cout << "\t\t\t" << "[1] CChild_c::vbptr for CParent_vf  (" << &pVTable[1][1] << ")  = " <<pVTable[1][1]<< endl;

  cout << (int*)&pVTable[2] << "\t" << "[2] CChild_c.ichild_ = " << (int)pVTable[2] << endl;
  cout << (int*)&pVTable[3] << "\t" << "[3] CParent_vf::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[3][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[3][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[3][i]<<"\t";
   pFun();
  }
  cout << (int*)&pVTable[4] << "\t" << "[4] CParent.iparent_ = " << (int)pVTable[4] << endl;
#else
  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_c.ichild_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CParent_vf::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[2][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[2][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[2][i]<<"\t";
   pFun();
  }
  cout << (int*)&pVTable[3] << "\t" << "[3] CParent.iparent_ = " << (int)pVTable[3] << endl;
#endif
#pragma warning(pop)
  cout << endl;
 }
}//om_ns_svi


#endif
