#ifndef OM_MULTIPLE_VIRTUAL_INHERITANCE_H_
#define OM_MULTIPLE_VIRTUAL_INHERITANCE_H_
#include "om-port.h"

// ؼ̳(2)̳е
// з̳еĻʵ
// ʱΪÿһصvbptrѾӷ̳е̳һvbptr
// ݳԱ
// ʵÿһʵ

// ڵ̳кͶؼ̳е£ǶĻʵַʵַ
// ߵַͬ(̳УԼؼ̳е),ǵַһ̶ƫ(ؼ̳еķ)

// һַַ֮ƫǲ̶ģΪֱһ̳еĻ
// ѹʵݷŵһһ಻ͬƫ
// еCParentCChild_avCChild_bvƫƵַǲȷģôƫƵַ仯.

// ʹָԱʱָָʵĻָ룬
// ָܸͼƫƣҵһּӵķָλá
// ʱʹvbptrָд洢ֵм㡣

namespace om_ns_mvi{
 class CParent_a {
 public:
  CParent_a ():iparent_ (10) {}
  virtual void f() { cout << "CParent_a::f()" << endl; }
  virtual void g() { cout << "CParent_a::g()" << endl; }
  virtual void h() { cout << "CParent_a::h()" << endl; }
  int iparent_;
 };

 class CParent_b {
 public:
  CParent_b ():iparent_ (20) {}
  virtual void f() { cout << "CParent_a::f()" << endl; }
  virtual void g() { cout << "CParent_a::g()" << endl; }
  virtual void h() { cout << "CParent_a::h()" << endl; }
  int iparent_;
 };

 class CChild_mv : virtual public CParent_a,public CParent_b {
 public:
  CChild_mv() : ichild_(1020){}
  virtual void f()  { cout << "CChild_mv::f()" << endl; }
  virtual void g()  { cout << "CChild_mv::g()" << endl; }
  virtual void cc() { cout << "CChild_mv::cc()" << endl; }
  int ichild_;
 };

 class CChild_mvv : virtual public CParent_a,virtual public CParent_b {
 public:
  CChild_mvv() : ichild_(2010){}
  virtual void f()  { cout << "CChild_mvv::f()" << endl; }
  virtual void g()  { cout << "CChild_mvv::g()" << endl; }
  virtual void cc() { cout << "CChild_mvv::cc()" << endl; }
  int ichild_;
 };

 void TestMutipleVirtualInheritance(){

  cout << "                        Test Multiple Virtual Inheritance                   "<<endl;
  cout << "***************************************************************************" <<endl;
  cout << endl << "--------------- Test CChild_mv" << endl;
  int i = 0;
  Ptr_Void_Fun pFun = NULL;
  int** pVTable = NULL;

  CChild_mv ccmv;
  pVTable = (int**)&ccmv;
  cout << "size: " << sizeof(ccmv) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CChild_mv::CParent_b::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   pFun();
  }

  cout << (int*)&pVTable[1] << "\t" << "[1] CParent_b.iparent_ = " << (int)pVTable[1] << endl;

#if defined(OM_COMPILER_MSVC_)
  cout << (int*)&pVTable[2] << "\t" << "[2] CChild_mv::vbptr->" << endl;
  cout << "\t\t\t" << "[0] CChild_mv::vbptr for CChild_mv  (" << &pVTable[2][0] << ")  = " <<pVTable[2][0]<< endl;
  cout << "\t\t\t" << "[1] CChild_mv::vbptr for CParent_a  (" << &pVTable[2][1] << ")  = " <<pVTable[2][1]<< endl;

  cout << (int*)&pVTable[3] << "\t" << "[3] CChild_mv.ichild_ = " << (int)pVTable[3] << endl;

  cout << (int*)&pVTable[4] << "\t" << "[4] CParent_a::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[4][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[4][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[4][i];
   pFun();
  }
  cout << (int*)&pVTable[5] << "\t" << "[5] CParent_a.iparent_ = " << (int)pVTable[5] << endl;
#else
  cout << (int*)&pVTable[2] << "\t" << "[2] CChild_mv.ichild_ = " << (int)pVTable[2] << endl;

  cout << (int*)&pVTable[3] << "\t" << "[3] CParent_a::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[3][i] != NULL; i++) {
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[3][i]<<"\t";
   pFun = (Ptr_Void_Fun)pVTable[3][i];
   pFun();
  }
  cout << (int*)&pVTable[4] << "\t" << "[4] CParent_a.iparent_ = " << (int)pVTable[4] << endl;
#endif

   cout << endl << "--------------- Test CChild_mvv" << endl;
   CChild_mvv ccmvv;
   pVTable = (int**)&ccmvv;
   cout << "size: " << sizeof(ccmvv) << endl;
   cout << (int*)&pVTable[0] << "\t" << "[0] CChild_mvv::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[0][i];
    pFun();
   }

#if defined(OM_COMPILER_MSVC_)
   cout << (int*)&pVTable[1] << "\t" << "[1] CChild_mvv::vbptr->" << endl;
   cout << "\t\t\t" << "[0] CChild_mv::vbptr for CChild_mv  (" << &pVTable[1][0] << ")  = " <<pVTable[1][0]<< endl;
   cout << "\t\t\t" << "[1] CChild_mv::vbptr for CParent_a  (" << &pVTable[1][1] << ")  = " <<pVTable[1][1]<< endl;
   cout << "\t\t\t" << "[1] CChild_mv::vbptr for CParent_b  (" << &pVTable[1][1] << ")  = " <<pVTable[1][2]<< endl;
   cout << (int*)&pVTable[2] << "\t" << "[2] CChild_mvv.ichild_ = " << (int)pVTable[2] << endl;


   cout << (int*)&pVTable[3] << "\t" << "[3] CParent_a::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[3][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[3][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[3][i];
    pFun();
   }
   cout << (int*)&pVTable[4] << "\t" << "[4] CParent_a.iparent_ = " << (int)pVTable[4] << endl;

   cout << (int*)&pVTable[5] << "\t" << "[5] CParent_b::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[5][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[5][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[5][i];
    pFun();
   }
   cout << (int*)&pVTable[6] << "\t" << "[6] CParent_b.iparent_ = " << (int)pVTable[6] << endl;
#else
   cout << (int*)&pVTable[1] << "\t" << "[2] CChild_mvv.ichild_ = " << (int)pVTable[1] << endl;


   cout << (int*)&pVTable[2] << "\t" << "[2] CParent_a::vfptr->" << endl;
   for (i = 0; (Ptr_Void_Fun)pVTable[2][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[2][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[2][i];
    pFun();
   }

   cout << (int*)&pVTable[3] << "\t" << "[3] CParent_a.iparent_ = " << (int)pVTable[3] << endl;

   cout << (int*)&pVTable[4] << "\t" << "[4] CParent_b::vfptr->" << endl;
   for (int i = 0; (Ptr_Void_Fun)pVTable[4][i] != NULL; i++) {
    cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[4][i]<<"\t";
    pFun = (Ptr_Void_Fun)pVTable[4][i];
    pFun();
   }
   cout << (int*)&pVTable[5] << "\t" << "[5] CParent_b.iparent_ = " << (int)pVTable[5] << endl;
#endif
 }
}

#endif
