#ifndef OM_SINGLE_INHERITANCE_H_
#define  OM_SINGLE_INHERITANCE_H_

//////////////////////////////////////////////////////////////////////////
// Եһ̳ϵµڴ沼(̳)
// class:
//       CParent
//       CChild : public CParent
//       CGrandChild : public CChild
//       CParent_no_virtual
//       CParent_no_virtual : CChild_no_virtual

// ̳ģʽ£̳ͨУҸûvirtual
//
// 1:û¶virtual ʱĲ :
//   ͵ַ->ߵַ
//   Ԫ(ûvfptr),Ԫ(ûvfptr).
// 2:¶virtual ʱĲ :
//   ͵ַ -> ߵַ
//    vfptr,ָvtable, Ԫ(ûvfptr), Ԫ

// ̳ģʽ£̳ͨУҸvirtual
// û¶virtual ʱĲ :
// ͵ַ -> ߵַ
// vfptr +Ԫ, Ԫ.
// 븸๫¸.


#include "om-port.h"

namespace om_ns_si {
 class CParent {
 public:
  CParent ():iparent_ (10) {}
  virtual ~CParent(){}
  virtual void f() { cout << "CParent::f()" << endl; }
  virtual void g() { cout << "CParent::g()" << endl; }
  virtual void h() { cout << "CParent::h()" << endl; }
  virtual void c() { cout << "CParent::c()" << endl;}
  int iparent_;
 };
 class CChild : public CParent {
 public:
  CChild():ichild_(100) {}
  virtual void f() { cout << "CChild::f()" << endl; }
  virtual void g1() { cout << "CChild::g1()" << endl; }
  virtual void h1() { cout << "CChild::h1()" << endl; }
  int ichild_;
 };
 class CGrandChild : public CChild{
 public:
  CGrandChild():igrandchild_(1000) {}
  virtual void f()  { cout << "CGrandChild::f()" << endl; }
  virtual void g1() { cout << "CGrandChild::g1()" << endl; }
  virtual void h2() { cout << "CGrandChild::h2()" << endl; }
  virtual void c()  { cout << "CGrandChild::c()" << endl;}
  int igrandchild_;
 };


 class CParent_no_virtual {
 public:
  CParent_no_virtual ():iparent_no_virtual_ (20) {}
  int iparent_no_virtual_;
 };
 class CChild_no_virtual :public CParent_no_virtual {
 public:
  CChild_no_virtual ():ichild_no_virtual_ (200) {}
  int ichild_no_virtual_;
 };

 inline void TestSingleInheritance() {
#pragma warning(push)
#pragma warning(disable:4312 4311)

  cout << "                        Test Single Inheritance                             "<<endl;
  cout << "***************************************************************************" <<endl;
  int i = 0;
  Ptr_Void_Fun pFun = NULL;
  int** pVTable = NULL;

  cout << endl <<"---------------Test CParent_no_virtual"<< endl;
  CParent_no_virtual cpnv;
  pVTable = (int**)&cpnv;
  cout << "size: " << sizeof(cpnv) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[1] CParent_no_virtual.iparent_no_virtual_ = " << (int)pVTable[0] << endl;

  cout << endl <<"--------------- Test CChild_no_virtual " << endl;
  CChild_no_virtual ccnv;
  pVTable = (int**)&ccnv;
  cout << "size: " << sizeof(ccnv) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CParent_no_virtual.iparent_no_virtual_ = " << (int)pVTable[0] << endl;
  cout << (int*)&pVTable[1] << "\t" << "[1] CChild_no_virtual.ichild_no_virtual_ = " << (int)pVTable[1] << endl;


  cout << endl <<"--------------- Test CParent" << endl;
  CParent cp;
  pVTable = (int**)&cp;
  cout << "size: " << sizeof(cp) << endl;

  cout << (int*)&pVTable[0] << "\t" <<"[0] CParent::vfptr->" << endl;

  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   if(i != DESTRUCTURE_IGNORE_1 && i!=DESTRUCTURE_IGNORE_2)
    pFun();
   else
    cout<<"Perhaps Destruct"<<endl;
  }
  cout << (int*)&pVTable[1] << "\t" << "[1] CParent.iparent_ = " << (int)pVTable[1] << endl;

  cout << endl <<"--------------- Test CChild" << endl;
  CChild cd;
  pVTable = (int**)&cd;
  cout << "size: " << sizeof(cd) << endl;

  cout << (int*)&pVTable[0] << "\t" <<"[0]  CChild::CParent::vfptr->" << endl;

  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   if(i != DESTRUCTURE_IGNORE_1 && i!=DESTRUCTURE_IGNORE_2)
    pFun();
   else
    cout<<"Perhaps Destruct"<<endl;
  }
  cout << (int*)&pVTable[1] << "\t" << "[1] CParent.iparent_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CChild.ichild_ = " << (int)pVTable[2] << endl;

  cout << endl <<"--------------- Test CGrandChild" << endl;
  CGrandChild gc;
  pVTable = (int**)&gc;

  cout << "size: " << sizeof(gc) << endl;
  cout << (int*)&pVTable[0] << "\t" << "[0] CGrandChild::CChild::CParent::vfptr->" << endl;
  for (int i = 0; (Ptr_Void_Fun)pVTable[0][i] != NULL; i++) {
   pFun = (Ptr_Void_Fun)pVTable[0][i];
   cout << "\t\t\t["<<i<<"] " << "\t" << (int*)pVTable[0][i]<<"\t";
   if(i != DESTRUCTURE_IGNORE_1 && i!=DESTRUCTURE_IGNORE_2)
    pFun();
   else
    cout<<"Perhaps Destruct"<<endl;
  }
  cout << (int*)&pVTable[1] << "\t" << "[1] CParent.iparent_ = " << (int)pVTable[1] << endl;
  cout << (int*)&pVTable[2] << "\t" << "[2] CChild.ichild_ = " << (int)pVTable[2] << endl;
  cout << (int*)&pVTable[3] << "\t" << "[3] CGrandChild.igrandchild_ = " << (int)pVTable[3] << endl;
#pragma warning(pop)
  cout<<endl;
 }
} // om_ns_si
#endif
